/usr/bin/makedist is in dist 1:3.5-36.0001-2.
This file is owned by root:root, with mode 0o755.
The actual contents of the file can be viewed below.
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276 277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 293 294 295 296 297 298 299 300 301 302 303 304 305 306 307 308 309 310 311 312 313 314 315 316 317 318 319 320 321 322 323 324 325 326 327 328 329 330 331 332 333 334 335 336 337 338 339 340 341 342 343 344 345 346 347 348 349 350 351 352 353 354 355 356 357 358 359 360 361 362 363 364 365 366 367 368 369 370 371 372 373 374 375 376 377 378 379 380 381 382 383 384 385 386 387 388 389 390 391 392 393 394 395 396 397 398 399 400 401 402 403 404 405 406 407 408 409 410 411 412 413 414 415 416 417 418 419 420 421 422 423 424 425 426 427 428 429 430 431 432 433 434 435 436 437 438 439 440 441 442 443 444 445 446 447 448 449 450 451 452 453 454 455 456 457 458 459 460 461 462 463 464 465 466 467 468 469 470 471 472 473 474 475 476 477 478 479 480 481 482 483 484 485 486 487 488 489 490 491 492 493 494 495 496 497 498 499 500 501 502 503 504 505 506 507 508 509 510 511 512 513 514 515 516 517 518 519 520 521 522 523 524 525 526 527 528 529 530 531 532 533 534 535 536 537 538 539 540 541 542 543 544 545 546 547 548 549 550 551 552 553 554 555 556 557 558 559 560 561 562 563 564 565 566 567 568 569 570 571 572 573 574 575 576 577 578 579 580 581 582 583 584 585 586 587 588 589 590 591 592 593 594 595 596 597 598 599 600 | #!/usr/bin/perl
eval 'exec perl -S $0 ${1+"$@"}'
if $running_under_some_shell;
# $Id: makedist.SH 31 2010-03-06 20:15:24Z rmanfredi $
#
# Copyright (c) 1991-1997, 2004-2006, Raphael Manfredi
#
# You may redistribute only under the terms of the Artistic Licence,
# as specified in the README file that comes with the distribution.
# You may reuse parts of this distribution only within the terms of
# that same Artistic Licence; a copy of which may be found at the root
# of the source tree for dist 4.0.
#
# $Log: makedist.SH,v $
# Revision 3.0.1.2 1994/01/24 13:58:20 ram
# patch16: modified call to manifake to trap exceptions manually
# patch16: removed final sed post-processing to allow 'make depend' target
# patch16: added ~/.dist_profile awareness
#
# Revision 3.0.1.1 1993/08/19 06:42:17 ram
# patch1: leading config.sh searching was not aborting properly
#
# Revision 3.0 1993/08/18 12:04:28 ram
# Baseline for dist 3.0 netwide release.
#
$version = '3.5';
$patchlevel = '0';
&profile; # Read ~/.dist_profile
require 'getopts.pl';
&usage unless &Getopts('c:f:dhvqs:V');
$ENV{'DIST'} = '/dev/null'; # Disable ~/.dist_profile
if ($opt_V) {
print STDERR "makedist $version PL$patchlevel\n";
exit 0;
} elsif ($opt_h) {
&usage;
}
$MAXKITSIZE = 50000 unless $MAXKITSIZE = $opt_s;
$KITOVERHEAD = 1800;
$FILEOVERHEAD = 90;
$CHOPSIZE = $MAXKITSIZE - $KITOVERHEAD - $FILEOVERHEAD;
$NEWMANI = 'MANIFEST.new' unless $NEWMANI = $opt_f;
$MANI = 'MANIFEST' unless $opt_f;
$PACKLIST = 'PACKLIST';
$PACKNOTES = 'PACKNOTES';
$tmpdir = "/tmp/MKst$$"; # Where to copy distribution
$tmpdir = '.' if $opt_q; # Quick mode: no need to copy distribution
&set_sig('aborted'); # Make sure we clean up in case of emergency
&readpackage;
&get_patchlevel;
eval '&manifake'; # Want to trap possible die and redirect to fatal
if ($@ ne '') {
chop($@);
&fatal($@);
}
if ($opt_c) { # Copy distribution only, no shell archive
&distcopy;
exit 0;
}
&distfake;
©right'init($copyright) if -f $copyright;
unlink <$package.kit? $package.kit??>;
chop($curdir = `pwd`);
chdir $tmpdir || die "Can't chdir to $tmpdir.\n";
&maniread;
&kitlists;
&manimake;
&kitbuild;
&cleanup;
exit 0;
# Physically build the kits
sub kitbuild {
$numkits = $#list;
if ($numkits > 9) {
$sp = '%02d';
} else {
$sp = '%d';
}
for ($kitnum = 1; $kitnum <= $numkits; $kitnum++) {
$list = $list[$kitnum];
$kit = sprintf("$package.kit" . $sp,$kitnum);
print "*** Making $kit ***\n";
open(KIT,">$curdir/$kit") || do fatal("Can't create $curdir/$kit: $!");
&kitleader;
@files = split(' ',$list);
reset 'X';
for $file (@files) {
$_ = $file;
while (s|^(.*)/.*$|$1|) {
push(@Xdirs,$_) unless $Xseen{$_}++;
}
}
print KIT "mkdir ",join(' ', sort @Xdirs)," 2>/dev/null\n";
foreach $file (@files) {
print "\t",$file,"\n" if $opt_v;
print KIT "echo Extracting $file\n";
print KIT "sed >$file <<'!STUFFY!FUNK!' -e 's/X//'\n";
open(FILE, $file);
©right'reset; # Reset copyright for new file
while (<FILE>) {
# Use Lock[e]r as a pattern in case it is applied on ourselves
s|Lock[e]r:.*\$|\$|; # Remove locker mark
print KIT ©right'filter($_, 'X');
}
close FILE;
print KIT "!STUFFY!FUNK!\n";
-x "$file" && (print KIT "chmod +x $file\n");
}
&kittrailer;
chmod 0755, $kit;
}
}
sub kitlists {
for $filename (keys %comment) {
next if $filename =~ m|/$|; # Skip directories
next if -d $filename; # Better safe than sorry
($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,
$blksize,$blocks) = stat($filename);
# Make sure file is not larger than the CHOPSIZE limit. If it is,
# a split is attempted.
if ($size > $CHOPSIZE) {
print "Splitting $filename...\n" if $opt_v;
$file_comment = $comment{$filename};
open(FILE, $filename) || die "Can't open $filename: $!\n";
$piece = 'AA';
($dir, $name) = ('.', $filename)
unless ($dir, $name) = ($filename =~ m|(.*)/(.*)|);
$chopped = $dir . '/' . substr($name, 0, 11);
$chopped =~ s|^\./||;
&fatal("There is already a split file named $chopped")
if defined $Chopped{$chopped};
$Chopped{$chopped} = $filename; # Association split <-> real file
$size = 0;
open(CURPIECE, ">$chopped:$piece") ||
&fatal("Can't create $chopped:$piece: $!");
while (<FILE>) {
if ($size + length($_) > $CHOPSIZE) {
close CURPIECE;
$size{"$chopped:$piece"} = $size;
$comment{"$chopped:$piece"} = "$file_comment (part $piece)";
push(@files, "$chopped:$piece");
print "\t$chopped:$piece ($size bytes)\n" if $opt_v;
$size = 0;
$piece++; # AA -> AB, etc...
open(CURPIECE, ">$chopped:$piece") ||
&fatal("Can't create $chopped:$piece: $!");
}
print CURPIECE $_;
$size += length($_);
}
close FILE;
close CURPIECE;
$size{"$chopped:$piece"} = $size;
$comment{"$chopped:$piece"} = "$file_comment (part $piece)";
push(@files, "$chopped:$piece");
print "\t$chopped:$piece ($size bytes)\n" if $opt_v;
delete $comment{$filename}; # File split, not in PACKLIST
} else {
$size += 1000000 if $filename =~ /README/;
$size{$filename} = $size;
push(@files, "$filename");
}
}
# Build a file PACKNOTES to reconstruct split files
if (defined %Chopped) {
open(PACKNOTES, ">$PACKNOTES") || &fatal("Can't create PACKNOTES: $!");
foreach (keys %Chopped) {
print PACKNOTES <<EOC;
echo 'Building $Chopped{$_}...'
cat $_:[A-Z][A-Z] > $Chopped{$_}
rm -f $_:[A-Z][A-Z]
EOC
}
close PACKNOTES;
push(@files, $PACKNOTES);
$comment{$PACKNOTES} = 'Script to reconstruct split files';
($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,
$blksize,$blocks) = stat($PACKNOTES);
$size{$PACKNOTES} = $size;
}
# Currently, file PACKLIST does not exist, so its size is unknown and
# it cannot be correctly put in one archive. Therefore, we take the
# size of MANIFEST.new, which will give us a good estimation.
push(@files, 'PACKLIST');
($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,
$blksize,$blocks) = stat($NEWMANI);
$size{$PACKLIST} = $size;
sub revnum { $size{$a} < $size{$b} ? 1 : $size{$a} > $size{$b} ? -1 : 0; }
@files = sort revnum @files;
for (@files) {
$size = $size{$_};
$size -= 1000000 if /README/;
$i=1;
while (($newtot = int($tot[$i] + $size + $size/40 + $FILEOVERHEAD)) >
$MAXKITSIZE-$KITOVERHEAD && $tot[$i]) {
$i++;
}
$tot[$i] = $newtot;
print "Adding $_ to kit $i giving $newtot bytes\n" if $opt_d;
$kit{$_} = $i;
$list[$i] .= " $_";
}
}
# Read manifest file and initialize the %comment array.
sub maniread {
do fatal("You don't have a $NEWMANI file. Run manifake")
unless -f "$NEWMANI";
open(NEWMANI,$NEWMANI) || do fatal("Can't read $NEWMANI: $!");
while (<NEWMANI>) {
($key,$val) = split(' ',$_,1) unless ($key,$val) = /^(\S+)\s+(.*)/;
$comment{$key} = $val;
}
close NEWMANI;
}
# MANIFEST and MANIFEST.new must say the same thing. Create the
# PACKLIST file (thus avoiding kit numbers in MANIFEST, which causes big
# patches when only re-ordering occurred). Note that PACKLIST should
# not appear in MANIFEST.new (the user may remove it).
sub manimake {
# Add built packlist
$comment{$PACKLIST} = 'Which files came with which kits';
open(PACKLIST, ">$PACKLIST") || do fatal("Can't create $PACKLIST: $!");
print PACKLIST
"After all the $package kits are run you should have the following files:
Filename Kit Description
-------- --- -----------
";
for (sort keys(comment)) {
printf PACKLIST "%-27s %2s %.47s\n", $_, $kit{$_}, $comment{$_};
}
close PACKLIST;
}
sub kitleader {
local($plevel);
$plevel = " at patchlevel $patch_level" if $patch_level ne '';
print KIT <<EOH;
#! /bin/sh
#
# This is $package version $baserev$plevel.
# Make a new directory for the $package sources, cd to it, and run kits 1 up
# to $numkits through sh. When all $numkits kits have been run, read README.
#
echo " "
cat <<EOM
This is $package $baserev$plevel, kit $kitnum (of $numkits):
If this shell archive is complete, the line "End of kit $kitnum (of $numkits)"
will echo at the end.
EOM
export PATH || (echo "Please use sh to unpack this archive." ; kill \$\$)
EOH
}
sub kittrailer {
$rangelist = '';
for ($i = 1; $i <= $numkits; $i++) {
$rangelist .= ' ' . $i;
}
print KIT <<EOM;
echo \"End of kit $kitnum (of $numkits)\"
echo \" \"
cat /dev/null >kit${kitnum}isdone
run=''
config=''
for iskit in$rangelist; do
if test -f kit\${iskit}isdone; then
run=\"\$run \$iskit\"
else
todo=\"\$todo \$iskit\"
fi
done
case \$todo in
'')
echo \"You have run all your kits.\"
EOM
if (defined %Chopped) { # Some splitting occurred
print KIT <<EOM;
if test -f $PACKNOTES; then
sh $PACKNOTES
else
echo \"You have to rebuild split files by hand (see $PACKLIST).\"
fi
EOM
}
if (-f "README" && -f "Configure") {
print KIT
" echo \"Please read README and then type Configure.\"
chmod 755 Configure\n";
} elsif (-f "README") {
print KIT
" echo \"Please read README first.\"\n";
} elsif (-f "Configure") {
print KIT
" echo \"Please run Configure first.\"
chmod 755 Configure\n";
}
print KIT <<EOM;
rm -f kit*isdone
;;
*) echo \"You have run\$run.\"
echo \"You still need to run\$todo.\"
;;
esac
: Someone might mail this, so exit before signature...
exit 0
EOM
}
sub get_patchlevel {
$patch_level = '';
if (-f 'patchlevel.h') {
open(PL, 'patchlevel.h');
while (<PL>) {
/^#define\s+PATCHLEVEL\s+(\w+)/ && ($patch_level = $1);
}
close PL;
}
}
sub distfake {
return if $opt_q;
local($sw);
$sw = 's' unless $opt_v;
mkdir($tmpdir, 0700) || die "Can't create directory $tmpdir.\n";
print "Building a copy of distribution in $tmpdir...\n" if $opt_v;
system 'perl', '-S', 'patcol', "-a$sw", '-f', $NEWMANI, '-d', $tmpdir;
system 'cp', $NEWMANI, "$tmpdir/$NEWMANI"
unless -f "$tmpdir/$NEWMANI" && !$opt_f;
}
sub distcopy {
local($sw); # Switch to force patcol to copy checked out files
&makedir($opt_c);
print "Building a copy of distribution in $opt_c...\n" if $opt_v;
$sw = 'c' if $opt_q;
$sw .= 's' unless $opt_v;
system 'perl', '-S', 'patcol', "-aRC$sw", '-f', $NEWMANI, '-d', $opt_c;
}
sub distrm {
return if $opt_q;
print "Removing distribution in $tmpdir...\n" if $opt_v;
chdir "/"; # Do not stay in removed directory...
system '/bin/rm', '-rf', "$tmpdir";
}
sub splitrm {
foreach $base (keys %Chopped) {
print "Removing split files for $base:\n" if $opt_v;
$piece = 'AA';
while (-f "$base:$piece") {
print "\t$base:$piece\n" if $opt_v;
unlink "$base:$piece";
$piece++; # AA -> AB, etc...
}
}
}
sub cleanup {
&distrm if -d $tmpdir;
if ($opt_q) {
&splitrm; # Remove in-place split files
unlink $PACKLIST, $PACKNOTES;
}
}
sub fatal {
local($reason) = shift(@_);
&cleanup;
die "$reason\n";
}
sub set_sig {
local($handler) = @_;
$SIG{'HUP'} = $handler;
$SIG{'INT'} = $handler;
$SIG{'QUIT'} = $handler;
$SIG{'TERM'} = $handler;
}
sub aborted {
&set_sig('IGNORE');
$opt_v = 1; # Force verbose message in distrm
&cleanup;
print "Aborted.\n";
exit 1;
}
sub usage {
print STDERR <<EOM;
Usage: makedist [-dhqvV] [-c dir] [-s size] [-f manifest]
-c : copy files in dir, do not build any shell archive.
-d : debug mode.
-f : use this file as manifest.
-h : print this help message and exits.
-q : quick mode: use checked-out files.
-s : set maximum pack size.
-v : verbose mode.
-V : print version number and exits.
EOM
exit 1;
}
sub readpackage {
if (! -f '.package') {
if (
-f '../.package' ||
-f '../../.package' ||
-f '../../../.package' ||
-f '../../../../.package'
) {
die "Run in top level directory only.\n";
} else {
die "No .package file! Run packinit.\n";
}
}
open(PACKAGE,'.package');
while (<PACKAGE>) {
next if /^:/;
next if /^#/;
if (($var,$val) = /^\s*(\w+)=(.*)/) {
$val = "\"$val\"" unless $val =~ /^['"]/;
eval "\$$var = $val;";
}
}
close PACKAGE;
}
sub manifake {
# make MANIFEST and MANIFEST.new say the same thing
if (! -f $NEWMANI) {
if (-f $MANI) {
open(IN,$MANI) || die "Can't open $MANI";
open(OUT,">$NEWMANI") || die "Can't create $NEWMANI";
while (<IN>) {
if (/---/) {
# Everything until now was a header...
close OUT;
open(OUT,">$NEWMANI") ||
die "Can't recreate $NEWMANI";
next;
}
s/^\s*(\S+\s+)[0-9]*\s*(.*)/$1$2/;
print OUT;
print OUT "\n" unless /\n$/; # If no description
}
close IN;
close OUT;
}
else {
die "You need to make a $NEWMANI file, with names and descriptions.\n";
}
}
}
package copyright;
# Read in copyright file
sub init {
local($file) = @_; # Copyright file
undef @copyright;
open(COPYRIGHT, $file) || die "Can't open $file: $!\n";
chop(@copyright = <COPYRIGHT>);
close COPYRIGHT;
}
# Reset the automaton for a new file.
sub reset {
$copyright_seen = @copyright ? 0 : 1;
$marker_seen = 0;
}
# Filter file, line by line, and expand the copyright string. The @COPYRIGHT@
# symbol may be preceded by some random comment. A leader can be defined and
# will be pre-pended to all the input lines.
sub filter {
local($line, $leader) = @_; # Leader is optional
return $leader . $line if $copyright_seen || $marker_seen;
$marker_seen = 1 if $line =~ /\$Log[:\$]/;
$copyright_seen = 1 if $line =~ /\@COPYRIGHT\@/;
return $leader . $line unless $copyright_seen;
local($comment, $trailer) = $line =~ /^(.*)\@COPYRIGHT\@\s*(.*)/;
$comment = $leader . $comment;
$comment . join("\n$comment", @copyright) . "\n";
}
# Filter output of $cmd redirected into $file by expanding copyright, if any.
sub expand {
local($cmd, $file) = @_;
if (@copyright) {
open(CMD,"$cmd|") || die "Can't start '$cmd': $!\n";
open(OUT, ">$file") || die "Can't create $file: $!\n";
&reset;
local($_);
while (<CMD>) {
print OUT &filter($_);
}
close OUT;
close CMD;
} else {
system "$cmd > $file";
die "Command '$cmd' failed!" if $?;
}
}
package main;
# Make directories for files
# E.g, for /usr/lib/perl/foo, it will check for all the
# directories /usr, /usr/lib, /usr/lib/perl and make
# them if they do not exist.
sub makedir {
local($_) = shift;
local($dir) = $_;
if (!-d && $_ ne '') {
# Make dirname first
do makedir($_) if s|(.*)/.*|\1|;
mkdir($dir, 0700) if ! -d $dir;
}
}
# Perform ~name expansion ala ksh...
# (banish csh from your vocabulary ;-)
sub tilda_expand {
local($path) = @_;
return $path unless $path =~ /^~/;
$path =~ s:^~([^/]+):(getpwnam($1))[$[+7]:e; # ~name
$path =~ s:^~:$ENV{'HOME'} || (getpwuid($<))[$[+7]:e; # ~
$path;
}
# Set up profile components into %Profile, add any profile-supplied options
# into @ARGV and return the command invocation name.
sub profile {
local($profile) = &tilda_expand($ENV{'DIST'} || '~/.dist_profile');
local($me) = $0; # Command name
$me =~ s|.*/(.*)|$1|; # Keep only base name
return $me unless -s $profile;
local(*PROFILE); # Local file descriptor
local($options) = ''; # Options we get back from profile
unless (open(PROFILE, $profile)) {
warn "$me: cannot open $profile: $!\n";
return;
}
local($_);
local($component);
while (<PROFILE>) {
next if /^\s*#/; # Skip comments
next unless /^$me/o;
if (s/^$me://o) { # progname: options
chop;
$options .= $_; # Merge options if more than one line
}
elsif (s/^$me-([^:]+)://o) { # progname-component: value
$component = $1;
chop;
s/^\s+//; # Trim leading and trailing spaces
s/\s+$//;
$Profile{$component} = $_;
}
}
close PROFILE;
return unless $options;
require 'shellwords.pl';
local(@opts);
eval '@opts = &shellwords($options)'; # Protect against mismatched quotes
unshift(@ARGV, @opts);
return $me; # Return our invocation name
}
|